﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using DG.Tweening;

public abstract class Grid : MonoBehaviour
{
    public GridManager gridManager;


    protected virtual void Start()
    {
        gridManager = FindObjectOfType<GridManager>();
    }

    public void ChangePosition(int row,int column)
    {
        DOTween.Kill(transform);
        transform.DOMove(gridManager.CalculateGridPosition(column, row), 0.5f);
  
    }

    public abstract void PlayerEntered(PlayerController playerController);



    private void OnCollisionEnter2D(Collision2D collision)
    {
        if (collision.gameObject.GetComponent<PlayerController>() == null) return;
        
        PlayerEntered(collision.gameObject.GetComponent<PlayerController>());
    }
    








}
