﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class GridManager : MonoBehaviour
{

    public enum Direction { Right, Left, Up, Down };

    [System.Serializable]
    public struct GridRow
    {
        [SerializeField] public Grid[] columns;
    }

    public GridRow[] gridRows;


    public Vector2 CalculateGridPosition(int Column, int Row)
    {

        return new Vector2(Column+1,Row+1);

    }

    public void MoveColumn(int columnIndex, Direction dir)
    {
        if (dir == Direction.Up)
        {

            Grid[] gridChangeArray =new Grid[gridRows.Length];
            for(int rowIndex=0;rowIndex<4;rowIndex++)
            {

                Grid varGrid=gridRows[rowIndex].columns[columnIndex];
                if (rowIndex < 3)
                {
                    varGrid.ChangePosition(rowIndex+1, columnIndex  );
                }else if (rowIndex == 3)
                {
                    varGrid.ChangePosition(0, columnIndex);
                }

                gridChangeArray[rowIndex] = varGrid;

            }

        
            for(int i =0;i<4;i++)
            {
                gridRows[(i + 1) % 4].columns[columnIndex] = gridChangeArray[i];

            }






        } 
        else if (dir == Direction.Down)
        {
            Grid[] gridChangeArray = new Grid[gridRows.Length];
            for (int rowIndex = 3; rowIndex >-1; rowIndex--)
            {

                Grid varGrid = gridRows[rowIndex].columns[columnIndex];
                if (rowIndex > 0)
                {
                    varGrid.ChangePosition(rowIndex - 1, columnIndex);
                }
                else if (rowIndex == 0)
                {
                    varGrid.ChangePosition(3, columnIndex);
                }

                gridChangeArray[rowIndex] = varGrid;

            }


            for (int i = 3; i > -1; i--)
            {
                gridRows[(i + 3) % 4].columns[columnIndex] = gridChangeArray[i];

            }

        }
       




    }

    //Right move row function
    public void MoveRow(int rowIndex, Direction dir)
    {
        
        if (dir == Direction.Right)
        {

            Grid[] gridChangeArray = new Grid[gridRows.Length];
            for (int columnIndex = 0; columnIndex < 4; columnIndex++)
            {

                Grid varGrid = gridRows[rowIndex].columns[columnIndex];
                if (columnIndex < 3)
                {
                    varGrid.ChangePosition(rowIndex , columnIndex+1);
                }
                else if (columnIndex == 3)
                {
                    varGrid.ChangePosition(rowIndex, 0);
                }

                gridChangeArray[columnIndex] = varGrid;

            }


            for (int i = 0; i < 4; i++)
            {
                gridRows[rowIndex].columns[(i + 1) % 4] = gridChangeArray[i];

            }






        }


        else if (dir == Direction.Left)
        {

            Grid[] gridChangeArray = new Grid[gridRows.Length];
            for (int columnIndex = 3; columnIndex > -1; columnIndex--)
            {

                Grid varGrid = gridRows[rowIndex].columns[columnIndex];
                if (columnIndex > 0)
                {
                    varGrid.ChangePosition(rowIndex, columnIndex - 1);
                }
                else if (columnIndex == 0)
                {
                    varGrid.ChangePosition(rowIndex, 3);
                }

                gridChangeArray[columnIndex] = varGrid;

            }


            for (int i = 3; i > -1; i--)
            {
                gridRows[rowIndex].columns[(i + 3) % 4] = gridChangeArray[i];

            }


          



        }



    }

}
