﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class GroundGrid : Grid
{
    [SerializeField] bool orientation = true;
    float gridLength = 0.5f;
    //true for left right orientation, false for up down orientation
    public override void PlayerEntered(PlayerController playerController )
    {
        StartCoroutine(WaitForResolve(playerController));
    }

    private IEnumerator WaitForResolve(PlayerController playerController)
    {
 

        yield return new WaitForSeconds(0.3f);

        float diffX = transform.position.x - playerController.lastPositionx;
        float diffY = transform.position.y - playerController.lastPositiony;

        if (orientation && Mathf.Abs(diffX)>gridLength)
        {

            //Debug.Log("player pos x" + playerController.lastPositionx);
            //Debug.Log("player pos y" + playerController.lastPositiony);
            //Debug.Log("object pos x" + transform.position.x);
            //Debug.Log("object pos y" + transform.position.y);


            //Debug.Log(diffX);
            playerController.MoveToGrid(Mathf.RoundToInt(transform.position.x+ diffX)-1  , Mathf.RoundToInt(transform.position.y)-1 );

            playerController.gameObject.GetComponent<Animator>().SetTrigger("WalkTrigger");
            playerController.UpdateLastPosition(Mathf.RoundToInt(transform.position.x), Mathf.RoundToInt(transform.position.y));
            playerController.inAir = false;
        }


        else if(!orientation && Mathf.Abs(diffY) > gridLength)
        {

            playerController.MoveToGrid(Mathf.RoundToInt(transform.position.x) -1, Mathf.RoundToInt(transform.position.y+diffY)-1 );

            playerController.UpdateLastPosition(Mathf.RoundToInt(transform.position.x), Mathf.RoundToInt(transform.position.y));
            playerController.inAir = false;
        }




        else{

            Debug.Log("YOU LOSE");
            Destroy(playerController.gameObject);
        }
    }



    // Start is called before the first frame update
    protected override void Start()
    {
        base.Start();
    }

    // Update is called once per frame
    void Update()
    {
        
    }


}
