﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class JumpGrid : Grid
{

    //true for riht turn false for left turn depending on the player

    float gridLength = 0.3f;
    //true for left right orientation, false for up down orientation
    public override void PlayerEntered(PlayerController playerController)
    {
        playerController.inAir = true;

        
        playerController.gameObject.GetComponent<Animator>().SetTrigger("JumpTrigger");
       
        float diffX = transform.position.x - playerController.lastPositionx;
        float diffY = transform.position.y - playerController.lastPositiony;
        if (Mathf.Abs(diffX) > Mathf.Abs(diffY) && Mathf.Abs(diffX) > gridLength)
        {

            //Debug.Log("player pos x" + playerController.lastPositionx);
            //Debug.Log("player pos y" + playerController.lastPositiony);
            //Debug.Log("object pos x" + transform.position.x);
            //Debug.Log("object pos y" + transform.position.y);


            //Debug.Log(diffX);
            playerController.MoveToGrid(Mathf.RoundToInt(transform.position.x + diffX) - 1, Mathf.RoundToInt(transform.position.y) - 1);

            playerController.gameObject.GetComponent<Animator>().SetTrigger("WalkTrigger");
            playerController.UpdateLastPosition(Mathf.RoundToInt(transform.position.x), Mathf.RoundToInt(transform.position.y));

        }


        else if (Mathf.Abs(diffX) < Mathf.Abs(diffY) && Mathf.Abs(diffY) > gridLength)
        {

            playerController.MoveToGrid(Mathf.RoundToInt(transform.position.x) - 1, Mathf.RoundToInt(transform.position.y + diffY) - 1);

            playerController.UpdateLastPosition(Mathf.RoundToInt(transform.position.x), Mathf.RoundToInt(transform.position.y));

        }
        
    }


    // Start is called before the first frame update
    protected override void Start()
    {
        base.Start();
    }


}
