﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using DG.Tweening;
public class PlayerController : MonoBehaviour
{
    // Start is called before the first frame update

    [SerializeField] GridManager gridManagerPlayer;
    [SerializeField] GameController gameController;
    public int lastPositionx = 0;
    public int lastPositiony = 0;
    public bool inAir = false;


    private void Start()
    {
        gridManagerPlayer=FindObjectOfType<GridManager>();
        gameController= FindObjectOfType<GameController>();

        lastPositionx = Mathf.RoundToInt(gameController.transform.GetChild(0).transform.position.x);
        lastPositiony = Mathf.RoundToInt(gameController.transform.GetChild(0).transform.position.y);

  

    }


    public void MoveToGrid(int columnIndex,int rowIndex)
    {
        Vector3 gridPosition = gridManagerPlayer.CalculateGridPosition(columnIndex, rowIndex);
        transform.DOMove(gridPosition,1f);

    }



    public void UpdateLastPosition(int posX,int posY)
    {
        lastPositionx = posX;
        lastPositiony = posY;


    }


    private void OnDestroy()
    {
        LevelLoader levelLoader = FindObjectOfType<LevelLoader>();
        levelLoader.LoadSameScreen();
    }
}
