﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class TurnGridLeft : Grid
{
    [SerializeField] bool orientation = true;
    //true for riht turn false for left turn depending on the player

    float gridLength = 0.3f;
    //true for left right orientation, false for up down orientation
    public override void PlayerEntered(PlayerController playerController)
    {
        Debug.Log("Trigger");
        StartCoroutine(WaitForResolve(playerController));
    }

    private IEnumerator WaitForResolve(PlayerController playerController)
    {


        yield return new WaitForSeconds(0.5f);


        float diffX = transform.position.x - playerController.lastPositionx;
        float diffY = transform.position.y - playerController.lastPositiony;

        if (Mathf.Abs(diffX) > 0)
        {
            playerController.MoveToGrid(Mathf.RoundToInt(transform.position.x) - 1, Mathf.RoundToInt(transform.position.y + diffX) - 1);

            playerController.UpdateLastPosition(Mathf.RoundToInt(transform.position.x), Mathf.RoundToInt(transform.position.y));

        }

        else if (Mathf.Abs(diffY) > 0)
        {
            playerController.MoveToGrid(Mathf.RoundToInt(transform.position.x - diffY) - 1, Mathf.RoundToInt(transform.position.y) - 1);

            playerController.UpdateLastPosition(Mathf.RoundToInt(transform.position.x), Mathf.RoundToInt(transform.position.y));


        }


    }
    // Start is called before the first frame update
    protected override void Start()
    {
        base.Start();
    }

    // Update is called once per frame
    void Update()
    {

    }
}
